/*
 * match_dc.c
 *
 * filipe@rnl.ist.utl.pt
 *
 */

#define __NO_VERSION__

#include <linux/config.h>

/*
#ifdef CONFIG_MODVERSIONS
#include <linux/modversions.h>
#endif
*/

#include <linux/smp.h>
#include <linux/module.h>
#include <linux/skbuff.h>
#include <linux/file.h>
#include <net/sock.h>

#include <linux/netfilter_ipv4/ip_tables.h>


#define SIZE_MIN    30
#define SIZE_MAX    200

static const unsigned char *dc_cmd[] = {
    "MyNick",
    "Lock",
    NULL
};

static const unsigned char *next_cmd( const unsigned char *data,
                                const unsigned char *end)
{
    while(data <= end)
        if(*data++ == '|') return data;
                return NULL;
}

int
match_dc( const unsigned char *data,
                const unsigned char *end)
{
    int count=0;

    if (end - data < SIZE_MIN || end - data > SIZE_MAX) return 0; 

    while(dc_cmd[count]) {
        if(*data != '$') return 0;    /* Quick Exit */
        if(end - data < strlen(dc_cmd[count])) return 0;
        if(memcmp(data + 1, dc_cmd[count], strlen(dc_cmd[count]))) return 0;

        data = next_cmd(data, end);        
        if(!data) return 0;

        count++;
    }


    return 1;
}
